
#ifndef _ROM_H
#define _ROM_H

#include "def.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef enum _CART_TYPE {
  CART_TYPE_SMS,
  CART_TYPE_GG
} CART_TYPE;

struct _CART {
  char          Name[MAX_FILE];
  unsigned long Size;
  unsigned long CRC;
  CART_TYPE     Type;
  unsigned char ROM [0x080000];
  unsigned char SRAM[0x8000];
} extern Cart;

extern BOOL Cart_Loaded;

BOOL Cart_LoadROM(const char *);
void Cart_FreeROM(void);
BOOL Cart_LoadSRAM(const char *);
BOOL Cart_SaveSRAM(const char *);

#ifdef __cplusplus
}
#endif

#endif // _ROM_H
