/** Z80: portable Z80 emulator *******************************/
/**                                                         **/
/**                          Codes.h                        **/
/**                                                         **/
/** This file contains implementation for the main table of **/
/** Z80 commands. It is included from Z80.c.                **/
/**                                                         **/
/** Copyright (C) Marat Fayzullin 1994-2002                 **/
/**     You are not allowed to distribute this software     **/
/**     commercially. Please, notify me, if you make any    **/
/**     changes to this file.                               **/
/*************************************************************/

case JR_NZ:   if(Z80.AF.B.l&Z_FLAG) Z80.PC.W++; else { Z80.ICount-=5;M_JR; } break;
case JR_NC:   if(Z80.AF.B.l&C_FLAG) Z80.PC.W++; else { Z80.ICount-=5;M_JR; } break;
case JR_Z:    if(Z80.AF.B.l&Z_FLAG) { Z80.ICount-=5;M_JR; } else Z80.PC.W++; break;
case JR_C:    if(Z80.AF.B.l&C_FLAG) { Z80.ICount-=5;M_JR; } else Z80.PC.W++; break;

case JP_NZ:   if(Z80.AF.B.l&Z_FLAG) Z80.PC.W+=2; else { M_JP; } break;
case JP_NC:   if(Z80.AF.B.l&C_FLAG) Z80.PC.W+=2; else { M_JP; } break;
case JP_PO:   if(Z80.AF.B.l&P_FLAG) Z80.PC.W+=2; else { M_JP; } break;
case JP_P:    if(Z80.AF.B.l&S_FLAG) Z80.PC.W+=2; else { M_JP; } break;
case JP_Z:    if(Z80.AF.B.l&Z_FLAG) { M_JP; } else Z80.PC.W+=2; break;
case JP_C:    if(Z80.AF.B.l&C_FLAG) { M_JP; } else Z80.PC.W+=2; break;
case JP_PE:   if(Z80.AF.B.l&P_FLAG) { M_JP; } else Z80.PC.W+=2; break;
case JP_M:    if(Z80.AF.B.l&S_FLAG) { M_JP; } else Z80.PC.W+=2; break;

case RET_NZ:  if(!(Z80.AF.B.l&Z_FLAG)) { Z80.ICount-=6;M_RET; } break;
case RET_NC:  if(!(Z80.AF.B.l&C_FLAG)) { Z80.ICount-=6;M_RET; } break;
case RET_PO:  if(!(Z80.AF.B.l&P_FLAG)) { Z80.ICount-=6;M_RET; } break;
case RET_P:   if(!(Z80.AF.B.l&S_FLAG)) { Z80.ICount-=6;M_RET; } break;
case RET_Z:   if(Z80.AF.B.l&Z_FLAG)    { Z80.ICount-=6;M_RET; } break;
case RET_C:   if(Z80.AF.B.l&C_FLAG)    { Z80.ICount-=6;M_RET; } break;
case RET_PE:  if(Z80.AF.B.l&P_FLAG)    { Z80.ICount-=6;M_RET; } break;
case RET_M:   if(Z80.AF.B.l&S_FLAG)    { Z80.ICount-=6;M_RET; } break;

case CALL_NZ: if(Z80.AF.B.l&Z_FLAG) Z80.PC.W+=2; else { Z80.ICount-=7;M_CALL; } break;
case CALL_NC: if(Z80.AF.B.l&C_FLAG) Z80.PC.W+=2; else { Z80.ICount-=7;M_CALL; } break;
case CALL_PO: if(Z80.AF.B.l&P_FLAG) Z80.PC.W+=2; else { Z80.ICount-=7;M_CALL; } break;
case CALL_P:  if(Z80.AF.B.l&S_FLAG) Z80.PC.W+=2; else { Z80.ICount-=7;M_CALL; } break;
case CALL_Z:  if(Z80.AF.B.l&Z_FLAG) { Z80.ICount-=7;M_CALL; } else Z80.PC.W+=2; break;
case CALL_C:  if(Z80.AF.B.l&C_FLAG) { Z80.ICount-=7;M_CALL; } else Z80.PC.W+=2; break;
case CALL_PE: if(Z80.AF.B.l&P_FLAG) { Z80.ICount-=7;M_CALL; } else Z80.PC.W+=2; break;
case CALL_M:  if(Z80.AF.B.l&S_FLAG) { Z80.ICount-=7;M_CALL; } else Z80.PC.W+=2; break;

case ADD_B:    M_ADD(Z80.BC.B.h);break;
case ADD_C:    M_ADD(Z80.BC.B.l);break;
case ADD_D:    M_ADD(Z80.DE.B.h);break;
case ADD_E:    M_ADD(Z80.DE.B.l);break;
case ADD_H:    M_ADD(Z80.HL.B.h);break;
case ADD_L:    M_ADD(Z80.HL.B.l);break;
case ADD_A:    M_ADD(Z80.AF.B.h);break;
case ADD_xHL:  I=RdZ80(Z80.HL.W);M_ADD(I);break;
case ADD_BYTE: I=RdZ80(Z80.PC.W++);M_ADD(I);break;

case SUB_B:    M_SUB(Z80.BC.B.h);break;
case SUB_C:    M_SUB(Z80.BC.B.l);break;
case SUB_D:    M_SUB(Z80.DE.B.h);break;
case SUB_E:    M_SUB(Z80.DE.B.l);break;
case SUB_H:    M_SUB(Z80.HL.B.h);break;
case SUB_L:    M_SUB(Z80.HL.B.l);break;
case SUB_A:    Z80.AF.B.h=0;Z80.AF.B.l=N_FLAG|Z_FLAG;break;
case SUB_xHL:  I=RdZ80(Z80.HL.W);M_SUB(I);break;
case SUB_BYTE: I=RdZ80(Z80.PC.W++);M_SUB(I);break;

case AND_B:    M_AND(Z80.BC.B.h);break;
case AND_C:    M_AND(Z80.BC.B.l);break;
case AND_D:    M_AND(Z80.DE.B.h);break;
case AND_E:    M_AND(Z80.DE.B.l);break;
case AND_H:    M_AND(Z80.HL.B.h);break;
case AND_L:    M_AND(Z80.HL.B.l);break;
case AND_A:    M_AND(Z80.AF.B.h);break;
case AND_xHL:  I=RdZ80(Z80.HL.W);M_AND(I);break;
case AND_BYTE: I=RdZ80(Z80.PC.W++);M_AND(I);break;

case OR_B:     M_OR(Z80.BC.B.h);break;
case OR_C:     M_OR(Z80.BC.B.l);break;
case OR_D:     M_OR(Z80.DE.B.h);break;
case OR_E:     M_OR(Z80.DE.B.l);break;
case OR_H:     M_OR(Z80.HL.B.h);break;
case OR_L:     M_OR(Z80.HL.B.l);break;
case OR_A:     M_OR(Z80.AF.B.h);break;
case OR_xHL:   I=RdZ80(Z80.HL.W);M_OR(I);break;
case OR_BYTE:  I=RdZ80(Z80.PC.W++);M_OR(I);break;

case ADC_B:    M_ADC(Z80.BC.B.h);break;
case ADC_C:    M_ADC(Z80.BC.B.l);break;
case ADC_D:    M_ADC(Z80.DE.B.h);break;
case ADC_E:    M_ADC(Z80.DE.B.l);break;
case ADC_H:    M_ADC(Z80.HL.B.h);break;
case ADC_L:    M_ADC(Z80.HL.B.l);break;
case ADC_A:    M_ADC(Z80.AF.B.h);break;
case ADC_xHL:  I=RdZ80(Z80.HL.W);M_ADC(I);break;
case ADC_BYTE: I=RdZ80(Z80.PC.W++);M_ADC(I);break;

case SBC_B:    M_SBC(Z80.BC.B.h);break;
case SBC_C:    M_SBC(Z80.BC.B.l);break;
case SBC_D:    M_SBC(Z80.DE.B.h);break;
case SBC_E:    M_SBC(Z80.DE.B.l);break;
case SBC_H:    M_SBC(Z80.HL.B.h);break;
case SBC_L:    M_SBC(Z80.HL.B.l);break;
case SBC_A:    M_SBC(Z80.AF.B.h);break;
case SBC_xHL:  I=RdZ80(Z80.HL.W);M_SBC(I);break;
case SBC_BYTE: I=RdZ80(Z80.PC.W++);M_SBC(I);break;

case XOR_B:    M_XOR(Z80.BC.B.h);break;
case XOR_C:    M_XOR(Z80.BC.B.l);break;
case XOR_D:    M_XOR(Z80.DE.B.h);break;
case XOR_E:    M_XOR(Z80.DE.B.l);break;
case XOR_H:    M_XOR(Z80.HL.B.h);break;
case XOR_L:    M_XOR(Z80.HL.B.l);break;
case XOR_A:    Z80.AF.B.h=0;Z80.AF.B.l=P_FLAG|Z_FLAG;break;
case XOR_xHL:  I=RdZ80(Z80.HL.W);M_XOR(I);break;
case XOR_BYTE: I=RdZ80(Z80.PC.W++);M_XOR(I);break;

case CP_B:     M_CP(Z80.BC.B.h);break;
case CP_C:     M_CP(Z80.BC.B.l);break;
case CP_D:     M_CP(Z80.DE.B.h);break;
case CP_E:     M_CP(Z80.DE.B.l);break;
case CP_H:     M_CP(Z80.HL.B.h);break;
case CP_L:     M_CP(Z80.HL.B.l);break;
case CP_A:     Z80.AF.B.l=N_FLAG|Z_FLAG;break;
case CP_xHL:   I=RdZ80(Z80.HL.W);M_CP(I);break;
case CP_BYTE:  I=RdZ80(Z80.PC.W++);M_CP(I);break;
               
case LD_BC_WORD: M_LDWORD(BC);break;
case LD_DE_WORD: M_LDWORD(DE);break;
case LD_HL_WORD: M_LDWORD(HL);break;
case LD_SP_WORD: M_LDWORD(SP);break;

case LD_PC_HL: Z80.PC.W=Z80.HL.W;break;
case LD_SP_HL: Z80.SP.W=Z80.HL.W;break;
case LD_A_xBC: Z80.AF.B.h=RdZ80(Z80.BC.W);break;
case LD_A_xDE: Z80.AF.B.h=RdZ80(Z80.DE.W);break;

case ADD_HL_BC:  M_ADDW(HL,BC);break;
case ADD_HL_DE:  M_ADDW(HL,DE);break;
case ADD_HL_HL:  M_ADDW(HL,HL);break;
case ADD_HL_SP:  M_ADDW(HL,SP);break;

case DEC_BC:   Z80.BC.W--;break;
case DEC_DE:   Z80.DE.W--;break;
case DEC_HL:   Z80.HL.W--;break;
case DEC_SP:   Z80.SP.W--;break;

case INC_BC:   Z80.BC.W++;break;
case INC_DE:   Z80.DE.W++;break;
case INC_HL:   Z80.HL.W++;break;
case INC_SP:   Z80.SP.W++;break;

case DEC_B:    M_DEC(Z80.BC.B.h);break;
case DEC_C:    M_DEC(Z80.BC.B.l);break;
case DEC_D:    M_DEC(Z80.DE.B.h);break;
case DEC_E:    M_DEC(Z80.DE.B.l);break;
case DEC_H:    M_DEC(Z80.HL.B.h);break;
case DEC_L:    M_DEC(Z80.HL.B.l);break;
case DEC_A:    M_DEC(Z80.AF.B.h);break;
case DEC_xHL:  I=RdZ80(Z80.HL.W);M_DEC(I);WrZ80(Z80.HL.W,I);break;

case INC_B:    M_INC(Z80.BC.B.h);break;
case INC_C:    M_INC(Z80.BC.B.l);break;
case INC_D:    M_INC(Z80.DE.B.h);break;
case INC_E:    M_INC(Z80.DE.B.l);break;
case INC_H:    M_INC(Z80.HL.B.h);break;
case INC_L:    M_INC(Z80.HL.B.l);break;
case INC_A:    M_INC(Z80.AF.B.h);break;
case INC_xHL:  I=RdZ80(Z80.HL.W);M_INC(I);WrZ80(Z80.HL.W,I);break;

case RLCA:
  I=Z80.AF.B.h&0x80? C_FLAG:0;
  Z80.AF.B.h=(Z80.AF.B.h<<1)|I;
  Z80.AF.B.l=(Z80.AF.B.l&~(C_FLAG|N_FLAG|H_FLAG))|I;
  break;
case RLA:
  I=Z80.AF.B.h&0x80? C_FLAG:0;
  Z80.AF.B.h=(Z80.AF.B.h<<1)|(Z80.AF.B.l&C_FLAG);
  Z80.AF.B.l=(Z80.AF.B.l&~(C_FLAG|N_FLAG|H_FLAG))|I;
  break;
case RRCA:
  I=Z80.AF.B.h&0x01;
  Z80.AF.B.h=(Z80.AF.B.h>>1)|(I? 0x80:0);
  Z80.AF.B.l=(Z80.AF.B.l&~(C_FLAG|N_FLAG|H_FLAG))|I; 
  break;
case RRA:
  I=Z80.AF.B.h&0x01;
  Z80.AF.B.h=(Z80.AF.B.h>>1)|(Z80.AF.B.l&C_FLAG? 0x80:0);
  Z80.AF.B.l=(Z80.AF.B.l&~(C_FLAG|N_FLAG|H_FLAG))|I;
  break;

case RST00:    M_RST(0x0000);break;
case RST08:    M_RST(0x0008);break;
case RST10:    M_RST(0x0010);break;
case RST18:    M_RST(0x0018);break;
case RST20:    M_RST(0x0020);break;
case RST28:    M_RST(0x0028);break;
case RST30:    M_RST(0x0030);break;
case RST38:    M_RST(0x0038);break;

case PUSH_BC:  M_PUSH(BC);break;
case PUSH_DE:  M_PUSH(DE);break;
case PUSH_HL:  M_PUSH(HL);break;
case PUSH_AF:  M_PUSH(AF);break;

case POP_BC:   M_POP(BC);break;
case POP_DE:   M_POP(DE);break;
case POP_HL:   M_POP(HL);break;
case POP_AF:   M_POP(AF);break;

case DJNZ: if(--Z80.BC.B.h) { Z80.ICount-=5;M_JR; } else Z80.PC.W++;break;
case JP:   M_JP;break;
case JR:   M_JR;break;
case CALL: M_CALL;break;
case RET:  M_RET;break;
case SCF:  S(C_FLAG);R(N_FLAG|H_FLAG);break;
case CPL:  Z80.AF.B.h=~Z80.AF.B.h;S(N_FLAG|H_FLAG);break;
case NOP:  break;
case OUTA: I=RdZ80(Z80.PC.W++);OutZ80(I,Z80.AF.B.h);break;
case INA:  I=RdZ80(Z80.PC.W++);Z80.AF.B.h=InZ80(I);break;

case HALT:
  Z80.PC.W--;
  Z80.IFF|=IFF_HALT;
  Z80.IBackup=0;
  Z80.ICount=0;
  break;

case DI:
  if(Z80.IFF&IFF_EI) Z80.ICount+=Z80.IBackup-1;
  Z80.IFF&=~(IFF_1|IFF_2|IFF_EI);
  break;

case EI:
  if(!(Z80.IFF&(IFF_1|IFF_EI)))
  {
    Z80.IFF|=IFF_2|IFF_EI;
    Z80.IBackup=Z80.ICount;
    Z80.ICount=1;
  }
  break;

case CCF:
  Z80.AF.B.l^=C_FLAG;R(N_FLAG|H_FLAG);
  Z80.AF.B.l|=Z80.AF.B.l&C_FLAG? 0:H_FLAG;
  break;

case EXX:
  J.W=Z80.BC.W;Z80.BC.W=Z80.BC1.W;Z80.BC1.W=J.W;
  J.W=Z80.DE.W;Z80.DE.W=Z80.DE1.W;Z80.DE1.W=J.W;
  J.W=Z80.HL.W;Z80.HL.W=Z80.HL1.W;Z80.HL1.W=J.W;
  break;

case EX_DE_HL: J.W=Z80.DE.W;Z80.DE.W=Z80.HL.W;Z80.HL.W=J.W;break;
case EX_AF_AF: J.W=Z80.AF.W;Z80.AF.W=Z80.AF1.W;Z80.AF1.W=J.W;break;  
  
case LD_B_B:   Z80.BC.B.h=Z80.BC.B.h;break;
case LD_C_B:   Z80.BC.B.l=Z80.BC.B.h;break;
case LD_D_B:   Z80.DE.B.h=Z80.BC.B.h;break;
case LD_E_B:   Z80.DE.B.l=Z80.BC.B.h;break;
case LD_H_B:   Z80.HL.B.h=Z80.BC.B.h;break;
case LD_L_B:   Z80.HL.B.l=Z80.BC.B.h;break;
case LD_A_B:   Z80.AF.B.h=Z80.BC.B.h;break;
case LD_xHL_B: WrZ80(Z80.HL.W,Z80.BC.B.h);break;

case LD_B_C:   Z80.BC.B.h=Z80.BC.B.l;break;
case LD_C_C:   Z80.BC.B.l=Z80.BC.B.l;break;
case LD_D_C:   Z80.DE.B.h=Z80.BC.B.l;break;
case LD_E_C:   Z80.DE.B.l=Z80.BC.B.l;break;
case LD_H_C:   Z80.HL.B.h=Z80.BC.B.l;break;
case LD_L_C:   Z80.HL.B.l=Z80.BC.B.l;break;
case LD_A_C:   Z80.AF.B.h=Z80.BC.B.l;break;
case LD_xHL_C: WrZ80(Z80.HL.W,Z80.BC.B.l);break;

case LD_B_D:   Z80.BC.B.h=Z80.DE.B.h;break;
case LD_C_D:   Z80.BC.B.l=Z80.DE.B.h;break;
case LD_D_D:   Z80.DE.B.h=Z80.DE.B.h;break;
case LD_E_D:   Z80.DE.B.l=Z80.DE.B.h;break;
case LD_H_D:   Z80.HL.B.h=Z80.DE.B.h;break;
case LD_L_D:   Z80.HL.B.l=Z80.DE.B.h;break;
case LD_A_D:   Z80.AF.B.h=Z80.DE.B.h;break;
case LD_xHL_D: WrZ80(Z80.HL.W,Z80.DE.B.h);break;

case LD_B_E:   Z80.BC.B.h=Z80.DE.B.l;break;
case LD_C_E:   Z80.BC.B.l=Z80.DE.B.l;break;
case LD_D_E:   Z80.DE.B.h=Z80.DE.B.l;break;
case LD_E_E:   Z80.DE.B.l=Z80.DE.B.l;break;
case LD_H_E:   Z80.HL.B.h=Z80.DE.B.l;break;
case LD_L_E:   Z80.HL.B.l=Z80.DE.B.l;break;
case LD_A_E:   Z80.AF.B.h=Z80.DE.B.l;break;
case LD_xHL_E: WrZ80(Z80.HL.W,Z80.DE.B.l);break;

case LD_B_H:   Z80.BC.B.h=Z80.HL.B.h;break;
case LD_C_H:   Z80.BC.B.l=Z80.HL.B.h;break;
case LD_D_H:   Z80.DE.B.h=Z80.HL.B.h;break;
case LD_E_H:   Z80.DE.B.l=Z80.HL.B.h;break;
case LD_H_H:   Z80.HL.B.h=Z80.HL.B.h;break;
case LD_L_H:   Z80.HL.B.l=Z80.HL.B.h;break;
case LD_A_H:   Z80.AF.B.h=Z80.HL.B.h;break;
case LD_xHL_H: WrZ80(Z80.HL.W,Z80.HL.B.h);break;

case LD_B_L:   Z80.BC.B.h=Z80.HL.B.l;break;
case LD_C_L:   Z80.BC.B.l=Z80.HL.B.l;break;
case LD_D_L:   Z80.DE.B.h=Z80.HL.B.l;break;
case LD_E_L:   Z80.DE.B.l=Z80.HL.B.l;break;
case LD_H_L:   Z80.HL.B.h=Z80.HL.B.l;break;
case LD_L_L:   Z80.HL.B.l=Z80.HL.B.l;break;
case LD_A_L:   Z80.AF.B.h=Z80.HL.B.l;break;
case LD_xHL_L: WrZ80(Z80.HL.W,Z80.HL.B.l);break;

case LD_B_A:   Z80.BC.B.h=Z80.AF.B.h;break;
case LD_C_A:   Z80.BC.B.l=Z80.AF.B.h;break;
case LD_D_A:   Z80.DE.B.h=Z80.AF.B.h;break;
case LD_E_A:   Z80.DE.B.l=Z80.AF.B.h;break;
case LD_H_A:   Z80.HL.B.h=Z80.AF.B.h;break;
case LD_L_A:   Z80.HL.B.l=Z80.AF.B.h;break;
case LD_A_A:   Z80.AF.B.h=Z80.AF.B.h;break;
case LD_xHL_A: WrZ80(Z80.HL.W,Z80.AF.B.h);break;

case LD_xBC_A: WrZ80(Z80.BC.W,Z80.AF.B.h);break;
case LD_xDE_A: WrZ80(Z80.DE.W,Z80.AF.B.h);break;

case LD_B_xHL:    Z80.BC.B.h=RdZ80(Z80.HL.W);break;
case LD_C_xHL:    Z80.BC.B.l=RdZ80(Z80.HL.W);break;
case LD_D_xHL:    Z80.DE.B.h=RdZ80(Z80.HL.W);break;
case LD_E_xHL:    Z80.DE.B.l=RdZ80(Z80.HL.W);break;
case LD_H_xHL:    Z80.HL.B.h=RdZ80(Z80.HL.W);break;
case LD_L_xHL:    Z80.HL.B.l=RdZ80(Z80.HL.W);break;
case LD_A_xHL:    Z80.AF.B.h=RdZ80(Z80.HL.W);break;

case LD_B_BYTE:   Z80.BC.B.h=RdZ80(Z80.PC.W++);break;
case LD_C_BYTE:   Z80.BC.B.l=RdZ80(Z80.PC.W++);break;
case LD_D_BYTE:   Z80.DE.B.h=RdZ80(Z80.PC.W++);break;
case LD_E_BYTE:   Z80.DE.B.l=RdZ80(Z80.PC.W++);break;
case LD_H_BYTE:   Z80.HL.B.h=RdZ80(Z80.PC.W++);break;
case LD_L_BYTE:   Z80.HL.B.l=RdZ80(Z80.PC.W++);break;
case LD_A_BYTE:   Z80.AF.B.h=RdZ80(Z80.PC.W++);break;
case LD_xHL_BYTE: WrZ80(Z80.HL.W,RdZ80(Z80.PC.W++));break;

case LD_xWORD_HL:
  J.B.l=RdZ80(Z80.PC.W++);
  J.B.h=RdZ80(Z80.PC.W++);
  WrZ80(J.W++,Z80.HL.B.l);
  WrZ80(J.W,Z80.HL.B.h);
  break;

case LD_HL_xWORD:
  J.B.l=RdZ80(Z80.PC.W++);
  J.B.h=RdZ80(Z80.PC.W++);
  Z80.HL.B.l=RdZ80(J.W++);
  Z80.HL.B.h=RdZ80(J.W);
  break;

case LD_A_xWORD:
  J.B.l=RdZ80(Z80.PC.W++);
  J.B.h=RdZ80(Z80.PC.W++); 
  Z80.AF.B.h=RdZ80(J.W);
  break;

case LD_xWORD_A:
  J.B.l=RdZ80(Z80.PC.W++);
  J.B.h=RdZ80(Z80.PC.W++);
  WrZ80(J.W,Z80.AF.B.h);
  break;

case EX_HL_xSP:
  J.B.l=RdZ80(Z80.SP.W);WrZ80(Z80.SP.W++,Z80.HL.B.l);
  J.B.h=RdZ80(Z80.SP.W);WrZ80(Z80.SP.W--,Z80.HL.B.h);
  Z80.HL.W=J.W;
  break;

case DAA:
  J.W=Z80.AF.B.h;
  if(Z80.AF.B.l&C_FLAG) J.W|=256;
  if(Z80.AF.B.l&H_FLAG) J.W|=512;
  if(Z80.AF.B.l&N_FLAG) J.W|=1024;
  Z80.AF.W=DAATable[J.W];
  break;

default:
  if(Z80.TrapBadOps)
    printf
    (
      "[Z80 %lX] Unrecognized instruction: %02X at PC=%04X\n",
      (long)Z80.User,RdZ80(Z80.PC.W-1),Z80.PC.W-1
    );
  break;
