
#ifndef _CONFIG_H
#define _CONFIG_H

#include "def.h"

// only for windows sdl version
#if !defined(PSP) && defined(SDL)

#include "sdl.h"

#define PSP_CTRL_SELECT    SDLK_SPACE
#define PSP_CTRL_START     SDLK_RETURN
#define PSP_CTRL_UP        SDLK_UP
#define PSP_CTRL_RIGHT     SDLK_RIGHT
#define PSP_CTRL_DOWN      SDLK_DOWN
#define PSP_CTRL_LEFT      SDLK_LEFT
#define PSP_CTRL_LTRIGGER  SDLK_q
#define PSP_CTRL_RTRIGGER  SDLK_w
#define PSP_CTRL_TRIANGLE  SDLK_s
#define PSP_CTRL_CIRCLE    SDLK_c
#define PSP_CTRL_CROSS     SDLK_z
#define PSP_CTRL_SQUARE    SDLK_a
#define PSP_CTRL_HOME      SDLK_F1
#define PSP_CTRL_HOLD      SDLK_F2
#define PSP_CTRL_NOTE      SDLK_F3

#endif

#ifdef __cplusplus
extern "C" {
#endif

typedef enum _RENDER_MODE {
  RENDER_MODE_NORMAL,
  RENDER_MODE_FIT,
  RENDER_MODE_WIDE,
  RENDER_MODE_FULL
} RENDER_MODE;

typedef enum _SHOT_FORMAT {
  SHOT_FORMAT_BMP,
  SHOT_FORMAT_PNG
} SHOT_FORMAT;

extern int           CPUFreq, RAMFreq, BUSFreq;
extern RENDER_MODE   RenderMode;
extern BOOL          VSync;
extern BOOL          ScreenSmoothing;
extern int           StateSlot;
extern BOOL          EnablePSG;
extern BOOL          EnableYM2413;
extern int           SoundVolume;
extern BOOL          RunBios;
extern char          ThemeFile[MAX_PATH];
extern char          LangFile[MAX_PATH];
extern char          ROMFolder[MAX_PATH];
extern char          SRAMFolder[MAX_PATH];
extern char          StateFolder[MAX_PATH];
extern char          CheatFolder[MAX_PATH];
extern char          ImageFolder[MAX_PATH];
extern char          ShotFolder[MAX_PATH];
extern SHOT_FORMAT   ShotFormat;

// emulator keys
struct _KEYS {
  unsigned int  Menu, Turbo, SaveState, LoadState;
  unsigned int  P1_Up, P1_Down, P1_Left, P1_Right,
                P1_One, P1_Two, P1_OneTwo, P1_Start,
                P1_Reset;
  unsigned int  P2_Up, P2_Down, P2_Left, P2_Right,
                P2_One, P2_Two, P2_OneTwo, P2_Start,
                P2_Reset;
} extern Keys;

extern BOOL          UseAnalogAsDButton;

// theme
extern char          BGFile[MAX_PATH];
extern char          FontsFile[MAX_PATH];
extern char          FontName[MAX_STRING];
extern int           FontType;
extern unsigned long FontColor[2];
extern unsigned long FontSelectColor[2];
extern unsigned long FontTitleColor[2];
extern unsigned long FontInGameColor[2];

void Config_Load(const char *);
BOOL Config_Save(const char *);
void Config_LoadTheme(const char *);

#ifdef __cplusplus
}
#endif

#endif // _CONFIG_H
