/* def.h - this file is part of segax project. Rodrigo Cardoso.
** Definitions. */

#ifndef _DEF_H
#define _DEF_H

#ifdef WIN32

#include <windows.h>

#else

#define BOOL  int
#define FALSE 0
#define TRUE  1

#define DWORD  unsigned long
#define ULONG  unsigned long
#define LONG   long
#define WORD   unsigned short
#define USHORT unsigned short
#define SHORT  short
#define BYTE   unsigned char
#define UCHAR  unsigned char
#define CHAR   char
#define INT    int
#define UINT   unsigned int

typedef struct _RECT {
  LONG left;
  LONG top;
  LONG right;
  LONG bottom;
} RECT;

typedef struct _POINT {
  LONG x;
  LONG y;
} POINT;

typedef struct _SIZE {
  LONG cx;
  LONG cy;
} SIZE;
 
#endif // WIN32

#ifndef STDCALL
#ifdef PSP
#define STDCALL
#else
#define STDCALL  __stdcall
#endif
#endif

#ifndef FASTCALL
#ifdef PSP
#define FASTCALL
#else
#define FASTCALL __fastcall
#endif
#endif

#ifndef CDECL
#ifdef PSP
#define CDECL
#else
#define CDECL    __cdecl
#endif
#endif

#ifndef INLINE
#ifdef __GNUC__
#define INLINE   __inline__
#else
#define INLINE   __inline
#endif
#endif

#ifdef __GNUC__
#define ALIGN(n) __attribute__((aligned(n)))
#else
#define ALIGN(n) __declspec(align(n))
#endif

#ifdef MAX_FILE
#undef MAX_FILE
#endif
#define MAX_FILE 64

#ifdef MAX_PATH
#undef MAX_PATH
#endif
#define MAX_PATH 512

#ifdef MAX_DIR
#undef MAX_DIR
#endif
#define MAX_DIR (MAX_PATH - MAX_FILE - 4)

#ifdef MAX_STRING
#undef MAX_STRING
#endif
#define MAX_STRING 64

#ifndef __cplusplus
typedef enum { false = 0, true = 1 } bool;
#endif


#endif // _DEF_H
