
#ifndef _RENDER_H
#define _RENDER_H

#include "def.h"

#ifdef __cplusplus
extern "C" {
#endif

extern unsigned char  BGNameDirty[0x200];
extern unsigned short BGNameList[0x200];
extern unsigned short BGListIndex;

extern unsigned short Render_Palette[0x100];

void Render_Init(void);
void Render_GGLine(void);
void Render_SMSLine(void);

extern unsigned short SMSColorTable[0x100];
struct _GG_COLOR {
  unsigned short rg;
  unsigned short b;
} extern GGColorTable[0x100];

#define Render_PaletteSync(i) {                                                                     \
  if(System.Flags & SF_GAME_GEAR)                                                                   \
    Render_Palette[i] = GGColorTable[VDP.CRAM[i << 1]].rg | GGColorTable[VDP.CRAM[(i << 1) | 1]].b; \
  else                                                                                              \
    Render_Palette[i] = SMSColorTable[VDP.CRAM[i]]; }

#ifdef PSP

void Render_UpdateBgCache(void);
void Render_SMSBgLine(unsigned char *linebuf);

#endif

#ifdef __cplusplus
}
#endif

#endif // _RENDER_H
