
#ifndef _TEXT_H
#define _TEXT_H

#include "def.h"

#ifdef __cplusplus
extern "C" {
#endif

#define DEFAULT_FONT_COLOR (0xFFFFFFFF)

BOOL Text_LoadFont(const char *, const char *, int);
void Text_SetFontColor(int, unsigned long, unsigned long);
void Text_InvertFontColor(int);

// valid draw flags
#define TDF_CENTER_SCREEN_X 0x00000001 // ignore x coordinate, center text in x axis
#define TDF_CENTER_SCREEN_Y 0x00000002 // ignore y coordinate, center text in y axis
#define TDF_CENTER          0x00000004 // the x coordinate is the center of the text
#define TDF_RIGHT           0x00000008 // the x coordinate is the right extreme of the text

void Text_Draw(int, const char *, int, int, unsigned long);

#ifdef __cplusplus
}
#endif

#endif // _TEXT_H
